
/*
  Web Server
 
 A simple web server that shows the value of the analog input pins.
 using an Arduino Wiznet Ethernet shield. 
 
 Circuit:
 * Ethernet shield attached to pins 10, 11, 12, 13
 * Analog inputs attached to pins A0 through A5 (optional)
 */

#include <SPI.h>
#include <util.h>
#include <EthernetUdp2.h>
#include <Ethernet2.h>
#include <Twitter.h>
#include <EthernetServer.h>
#include <EthernetClient.h>
#include <Dns.h>
#include <Dhcp.h>

// #include <Ethernet.h>
// #include <SPI.h>


// Enter a MAC address and IP address for your controller below.
// The IP address will be dependent on your local network:
byte mac[] = { 
/*  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED }; leonardo
    0x90, 0xA2, 0xDA, 0x10, 0xE3, 0x2F };*/
    0x90, 0xA2, 0xDA, 0x10, 0xE2, 0xA4 };
    
IPAddress ip(192, 168, 1, 177);

// Initialize the Ethernet server library
// with the IP address and port you want to use 
// (port 80 is default for HTTP):
EthernetServer server(8756);

int led = 13;
String T[10];
String chaine = "";

void setup() {
 // Open serial communications and wait for port to open:
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for Leonardo only
  }


  // start the Ethernet connection and the server:
  Ethernet.begin(mac, ip);
  server.begin();
  Serial.print("server is at ");
  Serial.println(Ethernet.localIP());

  //pinMode(led, OUTPUT);
}


void loop() {
  // listen for incoming clients
  EthernetClient client = server.available();
  if (client) {
    Serial.println("new client");
    // an http request ends with a blank line
    boolean currentLineIsBlank = true;
    
    while (client.connected()) {
      if (client.available()) {
      
        char c = client.read();
        chaine = chaine + c;
        chaine = chaine.substring(0,20);
        
        if (c == '\n') {
          Serial.println(chaine);
          String reply = analys_msg(chaine) + '\n';
          Serial.print("reply = ");
          Serial.println(reply);
          client.write(reply.c_str(), reply.length());
          chaine = "";
          continue;
        }   
      }
   }
     // give the web browser time to receive the data
    delay(1);
    // close the connection:
    client.stop();
    Serial.println("client disonnected");
  } 
}





String analys_msg(String msg){
    chaine.trim(); 
    int indice = 0;
    int i = 0;
    while (indice != - 1){
      /*Serial.print("indice =");
      Serial.println (chaine.indexOf(' ',indice + 1));*/
      T[i]= chaine.substring(indice, chaine.indexOf(' ',indice + 1));
      T[i].trim();
      i += 1;
      indice = chaine.indexOf(' ',indice + 1);
      if (i == 10){
        break;
      }
      
    }
      T[i + 1] = chaine.substring(indice, chaine.length());
      
       Serial.print("[");
       for (int h = 0; h < i; h++){
           Serial.print(T[h]);
           Serial.print(",");
         }
        Serial.println("]");
         
        if (i !=  3) {
          return "Error ! ";
          }
    
        led = T[1].toInt();

        if (T[0] != "LED"){
          return "Error led";
          }
    
        if (led < 0 or led > 16) {
          return "Error numero led";
          }
        
        if (T[2]== "ON"){
          //digitalWrite(led, HIGH);
          return "switch on led " + T[1];
        //  Serial.print("Switch on led ");
        //  Serial.println(led);
        }
        else if (T[2]== "OFF"){
         // digitalWrite(led, LOW);
         return "switch off led " + T[1];
         // Serial.print("Switch off led ");
         // Serial.println(led);
        }
        else {
          return "Error on/off";
        }
}





          
