/*
  Web Server
 
 A simple web server that shows the value of the analog input pins.
 using an Arduino Wiznet Ethernet shield. 
 
 Circuit:
 * Ethernet shield attached to pins 10, 11, 12, 13
 * Analog inputs attached to pins A0 through A5 (optional)
 */
#include <SPI.h>
#include <util.h>
#include <EthernetUdp2.h>
#include <Ethernet2.h>
#include <Twitter.h>
#include <EthernetServer.h>
#include <EthernetClient.h>
#include <Dns.h>
#include <Dhcp.h>

/*#include <SPI.h>
#include <Ethernet.h>*/

// Enter a MAC address and IP address for your controller below.
// The IP address will be dependent on your local network:
byte mac[] = { 
/*  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED }; leonardo
    0x90, 0xA2, 0xDA, 0x10, 0xE3, 0x2F };*/
  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };
  
IPAddress ip(192,168,1,177);

// Initialize the Ethernet server library
// with the IP address and port you want to use 
// (port 80 is default for HTTP):
EthernetServer server(8756);

int led;
String T[10];
int C[16];
String chaine = "";
int current;

void setup() {
 // Open serial communications and wait for port to open:
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for Leonardo only
  }


  // start the Ethernet connection and the server:
  Ethernet.begin(mac, ip);
  server.begin();
  Serial.print("server is at ");
  Serial.println(Ethernet.localIP());
  

}


void loop() {
  EthernetClient client = server.available();
  // listen for incoming clients
  //EthernetClient client = server.available();
  if (client) {
    Serial.println("new client");
    // an http request ends with a blank line
    //boolean currentLineIsBlank = true;
    
    while (client.connected()) {
      if (client.available()) {
      
        char c = client.read();
        chaine = chaine + c;
        chaine = chaine.substring(0,20);
        
        if (c == '\n') {
          Serial.println(chaine);
          String reply = analys_msg(chaine) + '\n';
          Serial.print("reply = ");
          Serial.println(reply);
     
          client.write(reply.c_str());
          client.write("\n");
          chaine = "";
          continue;
        }   
      }
   }
     // give the web browser time to receive the data
    delay(1);
    // close the connection:
    client.stop();
    Serial.println("client disonnected");
  } 
}




String analys_msg(String msg){
    chaine.trim(); 
    int indice = 0;
    int i = 0;
    while (indice != - 1){
     /* Serial.print("indice =");
      Serial.println (chaine.indexOf(' ',indice + 1));*/
      T[i]= chaine.substring(indice, chaine.indexOf(' ',indice + 1));
      T[i].trim();
      i += 1;
      indice = chaine.indexOf(' ',indice + 1);
      if (i == 10){
        break;
      }    
    }
      T[i + 1] = chaine.substring(indice, chaine.length());
      
       Serial.print("["); // test
       for (int h = 0; h < i; h++){
           Serial.print(T[h]);
           Serial.print(",");
         }
        Serial.println("]");
         
        
        if (T[0]== "ON"){
          if (i !=  2) {
          return "10 Error";
          }
          led = T[1].toInt();
           if (led < 0 or led > 15) {
          return "11 Error numero led";
          }
         /* for (int k = 2; k < 11; k++){
            if(T[k]!= " "){
              return "10 Error Syntax";
            }
          }*/
          //digitalWrite(led, HIGH);
          return "00 OK switch on led " + T[1];
         
        
        }
        if (T[0]== "OFF"){
          if (i !=  2) {
          return "10 Error";
          }
          led = T[1].toInt();
           if (led < 0 or led > 15) {
            return "11 Error numero led";
          }
         // digitalWrite(led, LOW);
         return "00 OK switch off led " + T[1];
         
        }
       

 //CURRENT               
 
        if (T[0] == "CURR?"){
          String curr;
          curr = "00 OK [";
          for (int h = 0; h < 15; h++){
            curr = curr + C[h] + ",";
          }
          curr = curr + C[15] + "]";
          return curr;
        }
        
        if (T[0]== "CURR"){
          if (i !=  3) {
          return "10 Error ";
          }
          led = T[1].toInt();
          current = T[2].toInt();
          Serial.print("led = ");
          Serial.println(led);
          if (led < 0 or led > 15) {
            return "11 Error numero led";
          }
          if (current < 0 or current >1000){
            return "13 Error current";
          }
         else {
          
          C[led] = current;
          Serial.print("[");
          for (int h = 0; h < 16; h++){
           Serial.print(C[h]);
           Serial.print(",");
         }
        Serial.println("]");
          return "00 OK";
        }
        
      }
// MONITOR

    if (T[0]== "MON"){
       if (i !=  2) {
          return "10 Error";
        }
      voie = T[1].toInt();
      if (voie < 0 or voie > 15) {
        return "11 Error numero voie";
      }
    return "00 OK monitor voie " + T[1];  
    }

//PULSE
     if (T[0]== "PULSE"){
       if (i !=  4) {
          return "10 Error";
        }
        voie = T[1].toInt();
        predelay = T[2].toInt();
        duree = T[3].toInt();
        if (voie < 0 or voie > 15) {
          return "11 Error numero voie";
        }
        if (predelay < 0 or duree < 0){
            return "13 Error temps";
          }

       
       else {
          
          return "10 Error Syntax";
        }
}

          
