
  
          /*
  Web Server
 
 A simple web server that shows the value of the analog input pins.
 using an Arduino Wiznet Ethernet shield. 
 
 Circuit:
 * Ethernet shield attached to pins 10, 11, 12, 13
 * Analog inputs attached to pins A0 through A5 (optional)
 */

#include <SPI.h>
#include <Ethernet.h>
#include <Wire.h>

//TEMP
#define DS1631_A0 0
#define DS1631_A1 0
#define DS1631_A2 0
#define DS1631_CFG_R1     1  
#define DS1631_CFG_R0     1  
#define DS1631_CFG_POL    0  
#define DS1631_CFG_1SHOT  0
#define DS1631_ADDR (0x48 | DS1631_A2<<2 | DS1631_A1<<1 | DS1631_A0)
#define DS1631_CFG (DS1631_CFG_R1 << 3 \
                    | DS1631_CFG_R0 << 2 \
                    | DS1631_CFG_POL << 1 \
                    | DS1631_CFG_1SHOT)
#define DS1631_DONE_MASK 0x80;
//

// Enter a MAC address and IP address for your controller below.
// The IP address will be dependent on your local network:
byte mac[] = { 
  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };
IPAddress ip(192,168,1,177);

// Initialize the Ethernet server library
// with the IP address and port you want to use 
// (port 80 is default for HTTP):
EthernetServer server(80);

int led;
int ledtest;
int ledtest_verte;
String T[10];
String chaine = "";




void setup() {
 // Open serial communications and wait for port to open:
  Serial.begin(9600);
  // start the Ethernet connection and the server:
  Ethernet.begin(mac, ip);
  server.begin();
  Serial.print("server is at ");
  Serial.println(Ethernet.localIP());

  

  //TEMP
   Wire.begin();
   Wire.beginTransmission(DS1631_ADDR);
   Wire.write(0x22); // Stop conversion
   Wire.endTransmission();
   
   Wire.beginTransmission(DS1631_ADDR);
   Wire.write(0xAC); // Access Configuration
   Wire.write(DS1631_CFG);
   Wire.endTransmission();

#if DS1631_CFG_1SHOT == 0
  // If continuous mode is set, start continuous conversion
  Wire.beginTransmission(DS1631_ADDR);
  Wire.write(0x51);
  Wire.endTransmission();
  delay(750); // delay to be sure that the first value is correct
#endif

  // UCSR0C = B00100100;

  // led de test
  ledtest = 7;
  pinMode(ledtest, OUTPUT);
  ledtest_verte = 5;
  pinMode(ledtest_verte, OUTPUT); 
}


void loop() {
  // listen for incoming clients
  EthernetClient client = server.available();
  if (client) {
    Serial.println("new client");
    // an http request ends with a blank line
    // boolean currentLineIsBlank = true;
    
    while (client.connected()) {
      if (client.available()) {
      
        char c = client.read();
        chaine = chaine + c;
        chaine = chaine.substring(0,20);
        
        if (c == '\n') {
          Serial.println(chaine.c_str());
          String reply = analys_msg(chaine);
          Serial.print("reply = ");
          Serial.println(reply.c_str());
          client.write(reply.c_str());
          client.write("\n");
          chaine = "";
          continue;
        }   
      }
   }
     // give the web browser time to receive the data
    delay(1);
    // close the connection:
    client.stop();
    Serial.println("client disonnected");
  } 
}





String analys_msg(String msg){
    chaine.trim(); 

    if (chaine == "TEMP?"){
      float temp = 0.0;

        if (DS1631_CFG_1SHOT){ 
          Wire.beginTransmission(DS1631_ADDR);
          Wire.write(0x51);
          Wire.endTransmission();
          delay(750); // delay for 12 bits precision
          // Now we wait the end of the conversion
          boolean tempAvailable = false;
          while (!tempAvailable){
             // See if the conversion is finished
            // in the configuration DEC
            Wire.beginTransmission(DS1631_ADDR);
            Wire.write(0xAC);
            Wire.endTransmission();
            Wire.requestFrom(DS1631_ADDR,1);
            Wire.available();
            tempAvailable = Wire.read() & DS1631_DONE_MASK;
            delay(10);
            }
        }
        // read result
      Wire.beginTransmission(DS1631_ADDR);
      Wire.write(0xAA); // read last conversion
      Wire.endTransmission();
      Wire.requestFrom(DS1631_ADDR,2);
      Wire.available();
      int tempMS = (int) Wire.read();
      Wire.available();
      int tempLS = (int) Wire.read();
      Serial.print("tempMS:");
      Serial.println(tempMS);
      Serial.print("tempLS:");
      Serial.println(tempLS);

      tempLS >>= 4; // last 4 bits are always 0
      if (tempMS & 0x80){ // if the signed bit = 1
        tempMS -= 256;
      }
      // Float conversion
      temp = (float) (tempMS + tempLS*0.0625);
      String temp_str = String(temp);
      return temp_str;
    }

    else {
      int indice = 0;
      int i = 0;
      while (indice != - 1){
        /*Serial.print("indice =");
        Serial.println (chaine.indexOf(' ',indice + 1));*/
        T[i]= chaine.substring(indice, chaine.indexOf(' ',indice + 1));
        T[i].trim();
        i += 1;
        indice = chaine.indexOf(' ',indice + 1);
        if (i == 10){
          break;
        }   
     }
        T[i + 1] = chaine.substring(indice, chaine.length());
      
       Serial.print("[");
       for (int h = 0; h < i; h++){
           Serial.print(T[h]);
           Serial.print(",");
         }
        Serial.println("]");
         
        if (i !=  3) {
          return "Error ! ";
          }
    
        led = T[1].toInt();
        Serial.println(led);

        if (T[0] != "LED"){
          return "Error led";
        }
    
        if (led < 2 or led > 16) {
          return "Error numero led";
          }
          
        
        if (T[2]== "ON"){
          digitalWrite(ledtest, HIGH);
          digitalWrite(ledtest_verte, HIGH);
          return String("switch on led ") + T[1];
        
        }
        else if (T[2]== "OFF"){
         digitalWrite(ledtest, LOW);
         digitalWrite(ledtest_verte, LOW);
         return "switch off led " + T[1];
         
        }
        else {
          return "Error on/off";
        }
    }
}





          

