

#include <SPI.h>
#include <util.h>
#include <EthernetUdp2.h>
#include <Ethernet2.h>
#include <Twitter.h>
#include <EthernetServer.h>
#include <EthernetClient.h>
#include <Dns.h>
#include <Dhcp.h>


byte mac[] = { 
  0x90, 0xA2, 0xDA, 0x10, 0xE2, 0xA4 };
  
IPAddress ip(192, 168, 1, 177);

EthernetServer server(8756);

String T[10];
String chaine = "";

//Pin connected to latch pin (ST_CP) of 74HC595
const int latchPin = 8;
//Pin connected to clock pin (SH_CP) of 74HC595
const int clockPin = 12;
//Pin connected to Data in (DS) of 74HC595
const int dataPin = 11;
const int enablePin = 7;


long long atoll(const char* ptr) {
  long long result = 0;
  while (*ptr && isdigit(*ptr)) {
    result *= 10;
    result += *ptr++ - '0';
  }
  return result;
}



void setup() {
  //set pins to output because they are addressed in the main loop
  pinMode(latchPin, OUTPUT);
  pinMode(dataPin, OUTPUT);  
  pinMode(clockPin, OUTPUT);
  pinMode(enablePin, OUTPUT);
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for Leonardo only
  }
  Ethernet.begin(mac, ip);
  server.begin();
  Serial.print("server is at ");
  Serial.println(Ethernet.localIP());
  
  Serial.println("reset");
}

void loop() {
  // listen for incoming clients
  EthernetClient client = server.available();
  if (client) {
    Serial.println("new client"); 
    //boolean currentLineIsBlank = true;
    
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();
    
        // write to the shift register with the correct bit set high:
         if (c == '\n'){
            Serial.println("[" + chaine + "]");
         // byte bitsToSet = chaine.toInt();
            uint64_t bitsToSet = atoll(chaine.c_str());
          //  uint64_t bitsToSet = chaine.toInt();
          //unsigned long int bitsToSet = chaine.toInt(); //32 bits
         // unsigned short int bitsToSet = chaine.toInt(); //16 bits
         
            Serial.println((unsigned long)(bitsToSet >> 32), BIN);
            Serial.println((unsigned long)(bitsToSet>> 32));
            Serial.println((unsigned long)bitsToSet, BIN);
            Serial.println((unsigned long)bitsToSet);
            Serial.println("--------------------------------------");
            
            
          //registerWrite(bitToSet, HIGH);
            digitalWrite(latchPin, LOW);
         // shift the bits out:
         
            shiftOut(dataPin, clockPin, MSBFIRST, (unsigned short)(255L & (bitsToSet >> 56)));
            Serial.println((unsigned short)(255L & (bitsToSet >> 56)) , BIN);

            shiftOut(dataPin, clockPin, MSBFIRST, (unsigned short)(255L & (bitsToSet >> 48)));
            Serial.println((unsigned short)(255L & (bitsToSet >> 48)) , BIN);
            
            shiftOut(dataPin, clockPin, MSBFIRST, (unsigned short)(255L & (bitsToSet >> 40)));
            Serial.println((unsigned short)(255L & (bitsToSet >> 40)) , BIN);

            shiftOut(dataPin, clockPin, MSBFIRST, (unsigned short)(255L & (bitsToSet >> 32)));
            Serial.println((unsigned short)(255L & (bitsToSet >> 32)) , BIN);
            
            shiftOut(dataPin, clockPin, MSBFIRST, (unsigned short)(255 & (bitsToSet >> 24)));
            Serial.println((unsigned short)(255 & (bitsToSet >> 24)), BIN);
            shiftOut(dataPin, clockPin, MSBFIRST, (unsigned short)(255 & (bitsToSet >> 16) ));
            Serial.println((unsigned short)(255 & (bitsToSet >> 16)) , BIN);
            shiftOut(dataPin, clockPin, MSBFIRST, (unsigned short)(255 & (bitsToSet >> 8 )));
            Serial.println( (unsigned short)(255 & (bitsToSet >> 8)), BIN);
            shiftOut(dataPin, clockPin, MSBFIRST,(unsigned short)( 255 & bitsToSet));
            Serial.println((unsigned short)(255 & (bitsToSet)) , BIN);
            
            // turn on the output so the LEDs can light up:
            digitalWrite(latchPin, HIGH);

            digitalWrite(enablePin, HIGH);
            delay(100);
            digitalWrite(enablePin, LOW);             
            chaine = "";
            continue;
          }
          else{
            chaine = chaine + c;
          }
    
        }
       }
     delay(1); 
     Serial.println("client disonnected");
  }
}



 
      
