

#include <SPI.h>
#include <util.h>
#include <EthernetUdp2.h>
#include <Ethernet2.h>
#include <Twitter.h>
#include <EthernetServer.h>
#include <EthernetClient.h>
#include <Dns.h>
#include <Dhcp.h>

#include <Wire.h>


#define AD5390_AD0 0 //1er AD5390
#define AD5390_AD1 0

#define AD5390_ADDR (0x54 | AD5390_AD1<<1 | AD5390_AD0)


#define CLOCK_FREQUENCY 100000



//TEMP
#define DS1631_A0 0
#define DS1631_A1 0
#define DS1631_A2 0
#define DS1631_CFG_R1     1  
#define DS1631_CFG_R0     1  
#define DS1631_CFG_POL    0  
#define DS1631_CFG_1SHOT  0
#define DS1631_ADDR (0x48 | DS1631_A2<<2 | DS1631_A1<<1 | DS1631_A0)
#define DS1631_CFG (DS1631_CFG_R1 << 3 \
                    | DS1631_CFG_R0 << 2 \
                    | DS1631_CFG_POL << 1 \
                    | DS1631_CFG_1SHOT)
#define DS1631_DONE_MASK 0x80;



byte mac[] = { 
  0x90, 0xA2, 0xDA, 0x10, 0xE2, 0xA4 };
  
IPAddress ip(192, 168, 1, 177);

EthernetServer server(8756);

String T[10];
String chaine = "";
String led = "";
int C[16];
int current;
int led1;


//Pin connected to latch pin (ST_CP) of 74HC595
const int latchPin = 8;
//Pin connected to clock pin (SH_CP) of 74HC595
const int clockPin = 12;
//Pin connected to Data in (DS) of 74HC595
const int dataPin = 11;
const int enablePin = 7;


long long atoll(const char* ptr) {
  long long result = 0;
  while (*ptr && isdigit(*ptr)) {
    result *= 10;
    result += *ptr++ - '0';
  }
  return result;
}



void setup() {
  //set pins to output because they are addressed in the main loop
  pinMode(latchPin, OUTPUT);
  pinMode(dataPin, OUTPUT);  
  pinMode(clockPin, OUTPUT);
  pinMode(enablePin, OUTPUT);
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for Leonardo only
  }
  Ethernet.begin(mac, ip);
  server.begin();
  Serial.print("server is at ");
  Serial.println(Ethernet.localIP());
  
  Serial.println("reset");

  Wire.begin();
  Wire.setClock(CLOCK_FREQUENCY);



 // Configuration of AD5390 (see Datasheet)
  Wire.beginTransmission(AD5390_ADDR);   
  Wire.write(0x0C); // Access Configuration
  Wire.write(0x36);
  Wire.write(0x00);
  Wire.endTransmission();

  writeMinAll();
  configure_registers(18446744073709551615L);

  


//TEMP
 //  Wire.begin();
   Wire.beginTransmission(DS1631_ADDR);
   Wire.write(0x22); // Stop conversion
   Wire.endTransmission();
   
   Wire.beginTransmission(DS1631_ADDR);
   Wire.write(0xAC); // Access Configuration
   Wire.write(DS1631_CFG);
   Wire.endTransmission();

#if DS1631_CFG_1SHOT == 0
  // If continuous mode is set, start continuous conversion
  Wire.beginTransmission(DS1631_ADDR);
  Wire.write(0x51);
  Wire.endTransmission();
  delay(750); // delay to be sure that the first value is correct
#endif
 
}



void loop() {
  // listen for incoming clients
  EthernetClient client = server.available();
  if (client) {
    Serial.println("new client"); 
    //boolean currentLineIsBlank = true;
    
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();
    
        // write to the shift register with the correct bit set high:
         if (c == '\n'){
            Serial.println("[" + chaine + "]");
            String reply = analys_msg(chaine);
            Serial.print("reply = ");
            Serial.println(reply.c_str());
            client.write(reply.c_str());
            client.write("\n");
            
                   
            chaine = "";
            continue;
          }
          else{
            chaine = chaine + c;
           // chaine = chaine.substring(0,20);
          }
    
        }
       }
     delay(1); 
     Serial.println("client disonnected");
  }
}


String analys_msg(String msg){
    chaine.trim(); 

    if (chaine == "TEMP?"){
      float temp = 0.0;

        if (DS1631_CFG_1SHOT){ 
          Wire.beginTransmission(DS1631_ADDR);
          Wire.write(0x51);
          Wire.endTransmission();
          delay(750); // delay for 12 bits precision
          // Now we wait the end of the conversion
          boolean tempAvailable = false;
          while (!tempAvailable){
             // See if the conversion is finished
            // in the configuration DEC
            Wire.beginTransmission(DS1631_ADDR);
            Wire.write(0xAC);
            Wire.endTransmission();
            Wire.requestFrom(DS1631_ADDR,1);
            Wire.available();
            tempAvailable = Wire.read() & DS1631_DONE_MASK;
            delay(10);
            }
        }
        // read result
      Wire.beginTransmission(DS1631_ADDR);
      Wire.write(0xAA); // read last conversion
      Wire.endTransmission();
      Wire.requestFrom(DS1631_ADDR,2);
      Wire.available();
      int tempMS = (int) Wire.read();
      Wire.available();
      int tempLS = (int) Wire.read();
      Serial.print("tempMS:");
      Serial.println(tempMS);
      Serial.print("tempLS:");
      Serial.println(tempLS);

      tempLS >>= 4; // last 4 bits are always 0
      if (tempMS & 0x80){ // if the signed bit = 1
        tempMS -= 256;
      }
      // Float conversion
      temp = (float) (tempMS + tempLS*0.0625);
      String temp_str = String(temp);
      return temp_str;
    }

    else {
      int indice = 0;
      int i = 0;
      while (indice != - 1){
        /*Serial.print("indice =");
        Serial.println (chaine.indexOf(' ',indice + 1));*/
        T[i]= chaine.substring(indice, chaine.indexOf(' ',indice + 1));
        T[i].trim();
        i += 1;
        indice = chaine.indexOf(' ',indice + 1);
        if (i == 32){
          break;
        }   
     }
        T[i + 1] = chaine.substring(indice, chaine.length());
      
       Serial.print("[");
       for (int h = 0; h < i; h++){
           Serial.print(T[h]);
           Serial.print(",");
         }
        Serial.println("]");
         
       

        //CURRENT               
 
        if (T[0] == "CURR?"){
          String curr;
          curr = "00 OK [";
          for (int h = 0; h < 15; h++){
            curr = curr + C[h] + ",";
          }
          curr = curr + C[15] + "]";
          return curr;
        }
        
        if (T[0]== "CURR"){
          if (i !=  3) {
            return "10 Error ";
          }
          led1 = T[1].toInt();
          current = T[2].toInt();
          Serial.print("led = ");
          Serial.println(led1);
          if (led1 < 0 or led1 > 15) {
            return "11 Error numero led";
          }
          if (current < 0 or current >1000){
            return "13 Error current";
          }
         else {
          
          C[led1] = current;
          Serial.print("[");
          for (int h = 0; h < 16; h++){
           Serial.print(C[h]);
           Serial.print(",");
          }
          Serial.println("]");
          return "00 OK";
        }
        
      }
        

        if (T[0] == "LEDS"){
          if (i !=  2) {
            return "10 Error";
         // byte bitsToSet = chaine.toInt();
         led = T[1];
         Serial.println(led.c_str());
         uint64_t bitsToSet = atoll(led.c_str());
       
          //  uint64_t bitsToSet = chaine.toInt();
          //unsigned long int bitsToSet = chaine.toInt(); //32 bits
         // unsigned short int bitsToSet = chaine.toInt(); //16 bits
         
      /*  Serial.println((unsigned long)(bitsToSet >> 32), BIN);
        Serial.println((unsigned long)(bitsToSet>> 32));
        Serial.println((unsigned long)bitsToSet, BIN);
        Serial.println((unsigned long)bitsToSet);
        Serial.println("--------------------------------------");*/
            
            
        configure_registers( bitsToSet);
          return "OK";
          }
         else {
          return "Error LEDS";
         }
        }  
    }
    
    
}
void configure_registers(uint64_t bitsToSet){
    //registerWrite(bitToSet, HIGH);
        digitalWrite(latchPin, LOW);
         // shift the bits out:
         
        shiftOut(dataPin, clockPin, MSBFIRST, (unsigned short)(255L & (bitsToSet >> 56)));
        Serial.println((unsigned short)(255L & (bitsToSet >> 56)) , BIN);

        shiftOut(dataPin, clockPin, MSBFIRST, (unsigned short)(255L & (bitsToSet >> 48)));
        Serial.println((unsigned short)(255L & (bitsToSet >> 48)) , BIN);
            
        shiftOut(dataPin, clockPin, MSBFIRST, (unsigned short)(255L & (bitsToSet >> 40)));
        Serial.println((unsigned short)(255L & (bitsToSet >> 40)) , BIN);

        shiftOut(dataPin, clockPin, MSBFIRST, (unsigned short)(255L & (bitsToSet >> 32)));
        Serial.println((unsigned short)(255L & (bitsToSet >> 32)) , BIN);
            
        shiftOut(dataPin, clockPin, MSBFIRST, (unsigned short)(255 & (bitsToSet >> 24)));
        Serial.println((unsigned short)(255 & (bitsToSet >> 24)), BIN);
        shiftOut(dataPin, clockPin, MSBFIRST, (unsigned short)(255 & (bitsToSet >> 16) ));
        Serial.println((unsigned short)(255 & (bitsToSet >> 16)) , BIN);
        shiftOut(dataPin, clockPin, MSBFIRST, (unsigned short)(255 & (bitsToSet >> 8 )));
        Serial.println( (unsigned short)(255 & (bitsToSet >> 8)), BIN);
        shiftOut(dataPin, clockPin, MSBFIRST,(unsigned short)( 255 & bitsToSet));
        Serial.println((unsigned short)(255 & (bitsToSet)) , BIN);
            
            // turn on the output so the LEDs can light up:
        digitalWrite(latchPin, HIGH);

        digitalWrite(enablePin, HIGH);
        delay(100);
        digitalWrite(enablePin, LOW); 

}

int writeValue (int channel, int value){
  if ( value < 0 || value > 16383 || channel < 0 || channel > 15){
      return -1;}
  unsigned short A = (unsigned short)channel;
  
 
  unsigned short val = (unsigned short) value;
  val = val | 0xC000;  // =49152, reg1=reg0=1
  Serial.print("val = ");
  Serial.println(val);
  Serial.print("A = ");
  Serial.println(A);
  byte B = (byte)((val & 0xff00) >> 8);
  Serial.print("B = ");
  Serial.println(B);
  byte C = (byte) (val & 0x00ff);
  Serial.print("C = ");
  Serial.println(C);
  
  Wire.beginTransmission(AD5390_ADDR);   
  Wire.write(A); // Access Configuration
  Wire.write(B);
  Wire.write(C);
  Wire.endTransmission();

  return(0);
}



void writeMinAll(){
  Wire.beginTransmission(AD5390_ADDR);
  Wire.write(0x01); 
  Wire.write(0x00);
  Wire.write(0x00);
  Wire.endTransmission();

  Wire.beginTransmission(AD5390_ADDR);    
  Wire.write(0x02); 
  Wire.write(0x00);
  Wire.write(0x00);
  Wire.endTransmission();
  
}

 

void writeMaxAll(){
   Wire.beginTransmission(AD5390_ADDR);
   Wire.write(0x01); 
   Wire.write(0x1F);
   Wire.write(0xFF);
   Wire.endTransmission();

   Wire.beginTransmission(AD5390_ADDR);
   Wire.write(0x02); 
   Wire.write(0x00);
   Wire.write(0x00);
   Wire.endTransmission();
}
  



      
